/****************************************************************************************
	CarbonizedMenus.cp
	
	Copyright  1999 Red Shed Software. All rights reserved.
	by Jonathan 'Wolf' Rentzsch (jon@redshed.net)
	
	Commenter	Date				Comment
	---------	-----------------	-----------------------------------------------------
	wolf		Thu, Jun 24, 1999	Created.
	
	************************************************************************************/

#include	"CarbonizedMenus.h"
#include	"StandardToolbox.h"
#include	"jGNE.h"
#include	"HideMenubar.h"
#include	"require.h"
#include	"RootMenu.h"
#include	"MacExceptions.h"
#include	"MenuList.h"
#include	"TextServices.h"
#include	"algorithm.h"
#include	"AppleEventUtilities.h"
#include	"TestOptionKey.h"

/**************************
*	
*	Types
*	
**************************/
#pragma mark	--Types--

#if GENERATINGCFM
	typedef	UniversalProcPtr					ExitToShellProc;
	#define	uppExitToShellProcInfo				(ProcInfoType)kPascalStackBased
	#define	NewExitToShellProc(PROC)			(ExitToShellProc)NewRoutineDescriptor((ProcPtr)(PROC), uppExitToShellProcInfo, GetCurrentArchitecture())
	#define	CallExitToShellProc(PROC)			CallUniversalProc((UniversalProcPtr)(PROC), uppExitToShellProcInfo)
	#define	DeclareExitToShellProc(VAR, PROC)	DeclareCFMRoutineDescriptor(ExitToShellProc, (VAR), PROC, uppExitToShellProcInfo)
#else
	typedef	pascal	void						(*ExitToShellProc)();
	#define	NewExitToShellProc(PROC)			((ExitToShellProc)(PROC))
	#define	CallExitToShellProc(PROC)			(*(PROC))()
	#define	DeclareExitToShellProc(VAR, PROC)	DeclareClassicRoutineDescriptor(ExitToShellProc, (VAR), (PROC))
#endif

#if GENERATINGCFM
	typedef	UniversalProcPtr																					NewWindowProc;
	#define	uppNewWindowProcInfo																				(ProcInfoType)kPascalStackBased|RESULT_SIZE_TYPE(WindowPtr)|STACK_ROUTINE_PARAMETER_TYPE(1, void*)|STACK_ROUTINE_PARAMETER_TYPE(2, Rect*)|STACK_ROUTINE_PARAMETER_TYPE(3, ConstStr255Param)|STACK_ROUTINE_PARAMETER_TYPE(4, Boolean)|STACK_ROUTINE_PARAMETER_TYPE(5, short)|STACK_ROUTINE_PARAMETER_TYPE(6, WindowPtr)|STACK_ROUTINE_PARAMETER_TYPE(7, Boolean)|STACK_ROUTINE_PARAMETER_TYPE(8, long)
	#define	NewNewWindowProc(PROC)																				(NewWindowProc)NewRoutineDescriptor((ProcPtr)(PROC), uppNewWindowProcInfo, GetCurrentArchitecture())
	#define	CallNewWindowProc(PROC, WSTORAGE, BOUNDSRECT, TITLE, VISIBLE, THEPROC, BEHIND, GOAWAYFLAG, REFCON)	(PROC)?CallUniversalProc((UniversalProcPtr)(PROC), uppNewWindowProcInfo, (WSTORAGE), (BOUNDSRECT), (TITLE), (VISIBLE), (THEPROC), (BEHIND), (GOAWAYFLAG), (REFCON)):0
	#define	DeclareNewWindowProc(VAR, PROC)																		DeclareCFMRoutineDescriptor(NewWindowProc, (VAR), PROC, uppNewWindowProcInfo)
#else
	typedef	pascal	WindowPtr																				(*NewWindowProc)( void* wStorage, Rect* boundsRect, ConstStr255Param title, Boolean visible, short theProc, WindowPtr behind, Boolean goAwayFlag, long refCon );
	#define	NewNewWindowProc(PROC)																				((NewWindowProc)(PROC))
	#define	CallNewWindowProc(PROC, WSTORAGE, BOUNDSRECT, TITLE, VISIBLE, THEPROC, BEHIND, GOAWAYFLAG, REFCON)	(PROC)?(*(PROC))((WSTORAGE), (BOUNDSRECT), (TITLE), (VISIBLE), (THEPROC), (BEHIND), (GOAWAYFLAG), (REFCON)):0
	#define	DeclareNewWindowProc(VAR, PROC)																		DeclareClassicRoutineDescriptor(NewWindowProc, (VAR), (PROC))
#endif

/**************************
*	
*	Globals
*	
**************************/
#pragma mark	-
#pragma mark	--Globals--

ExitToShellProc		gExitToShell;
UInt32				gClassID = 'AAAA';
bool				gInstalledSysHandler = false;

/**************************
*	
*	Funky Protos
*	
**************************/
#pragma mark	-
#pragma mark	--Funky Protos--

	pascal
	void
MyExitToShell();
DeclareExitToShellProc( gMyExitToShell, MyExitToShell );

	pascal
	void
MyFilter(
	EventRecord	*event,
	Boolean		*result );
DeclareRoutineDescriptor( GetNextEventFilterUPP, gMyFilter, MyFilter, uppGetNextEventFilterProcInfo );

	pascal
	WindowPtr
MyNewWindow(
	void				*wStorage,
	 Rect				*boundsRect,
	 ConstStr255Param 	title,
	 Boolean 			visible,
	 short 				theProc,
	 WindowPtr		 	behind,
	 Boolean 			goAwayFlag,
	 long 				refCon );
DeclareNewWindowProc( gMyNewWindow, MyNewWindow );

	pascal
	OSErr
HandleHackEvent(
	const	AppleEvent	*event,
			AppleEvent	*reply,
			long		refCon );
DeclareAEEventHandlerProc( gHandleHackEvent, HandleHackEvent );

	void
GetMBAR(
	StandardTask *task );

	void
Updater(
	StandardTask *task );

/****************************************************************************************
*	
*	Implementation
*	
****************************************************************************************/
#pragma mark	-
#pragma mark	--Implementation--

/****************************************************************************************
	Commenter	Date				Comment
	---------	-----------------	-----------------------------------------------------
	wolf		Mon, Jan 11, 1999	Created.
	
	************************************************************************************/

	void
main()
{
	OSErr	err = StandardInitialize();
	
	if( !err && !StandardGetBackgroundOnly() )
		err = StandardLoadMenubar( kMenubar, kAppleMenu, 0 );
	
	if( !err ) {
		gExitToShell = (ExitToShellProc) StandardGetTrapAddress( _ExitToShell );
		SetToolTrapAddress( (UniversalProcPtr) gMyExitToShell, _ExitToShell );
	}
	
	if( !err ) {
		SetToolTrapAddress( (UniversalProcPtr) gMyNewWindow, _NewWindow );
	}
	
	if( !err ) {
		err = InstalljGNE( gMyFilter );
	}
	
	if( !err ) {
		while( !err && !gInstalledSysHandler ) {
			AEEventHandlerUPP	ignored1;
			long				ignored2;
			err = AEGetEventHandler( gClassID, gClassID, &ignored1, &ignored2, true );
			if( err == errAEHandlerNotFound ) {
				err = AEInstallEventHandler( gClassID, gClassID, gHandleHackEvent, SetCurrentA5(), true );
				if( !err )
					gInstalledSysHandler = true;
			} else if( err == noErr ) {
				++gClassID;
			}
		}
	}
	
	if( !err ) {
		HideMenuBarX();
	}
	
	/*try {
		RootMenu	*rootMenu = new RootMenu;
	} catch( const XErr &err ) {
		err.Debug();
	}*/
	
	if( !err ) {
		StandardTask	getMBAR;
						StandardInitializeTask( &getMBAR );
						getMBAR.proc = GetMBAR;
						StandardScheduleTask( &getMBAR, 30 );
		StandardEventLoop();
	}
}

/****************************************************************************************
	Commenter	Date				Comment
	---------	-----------------	-----------------------------------------------------
	wolf		Thu, Jun 24, 1999	Created.
	
	************************************************************************************/

	pascal
	void
MyExitToShell()
{
	static	Boolean	done = false;
	long			a5 = SetCurrentA5();	//	Load a5 from LowMem globals and save old value.
	ExitToShellProc	original = gExitToShell;
	
	if( !done ) {
		done = true;
		{
			CleanUp	cleanUp;
		}
		RemovejGNE();
		if( gInstalledSysHandler )
			AERemoveEventHandler( gClassID, gClassID, gHandleHackEvent, true );
		if( gMenuBarHidden )
			ShowMenuBarX();
		
		CleanUp	cleanUp;
	}
	
	//	Restore found a5.
	SetA5( a5 );
	CallExitToShellProc( original );
}

/****************************************************************************************
	Commenter	Date				Comment
	---------	-----------------	-----------------------------------------------------
	wolf		Wed, Feb 3, 1999	Created.
	
	************************************************************************************/

	void
CustomHandleMenuCommand(
	UserEventPtr	event )
{
	switch( event->menu ) {
		case kAppleMenu:
			switch( event->menuItem ) {
				case kAboutMenuItem:
					SysBeep( 20 );
					break;
				default:
					StandardHandleAppleMenuCommand( event );
					break;
			}
			break;
		case kFileMenu:
			switch( event->menuItem ) {
				case kQuitMenuItem:
					StandardBeginQuitting();
					break;
				default:
					break;
			}
			break;
		case kEditMenu:
			switch( event->menuItem ) {
				case kUndoMenuItem:
					
					break;
				case kCutMenuItem:
					
					break;
				case kCopyMenuItem:
					
					break;
				case kPasteMenuItem:
					
					break;
				case kClearMenuItem:
					
					break;
				default:
					break;
			}
			break;
		default:
			break;
	}
}

/****************************************************************************************
	Commenter	Date				Comment
	---------	-----------------	-----------------------------------------------------
	wolf		Wed, Feb 3, 1999	Created.
	
	************************************************************************************/

	OSErr
CustomHandleOpenItem(
	const	FSSpecPtr	/*item*/ )
{
	return( noErr );
}

/****************************************************************************************
	Commenter	Date				Comment
	---------	-----------------	-----------------------------------------------------
	wolf		Thu, Jun 24, 1999	Created.
	
	************************************************************************************/

	pascal
	void
MyFilter(
	EventRecord	*event,
	Boolean		*result )
{
	if( event->what == mouseDown ) {
		WindowPtr	w;
		short		partCode = FindServiceWindow( event->where, &w );
		if( partCode && partCode != inMenuBar ) {
			list< AbstractMenuWindow* >::iterator	wi = find( gMenus.begin(), gMenus.end(), (AbstractMenuWindow*) GetWRefCon( w ) );
			if( wi != gMenus.end() ) {
				event->what = nullEvent;
				(*wi)->MouseDown( event );
			}
		}
	}
	GetNextEventFilterUPP	next = GetNextjGNE();
	if( next )
		CallGetNextEventFilterProc( next, event, result );
}

/****************************************************************************************
	Commenter	Date				Comment
	---------	-----------------	-----------------------------------------------------
	wolf		Thu, Jun 24, 1999	Created.
	
	************************************************************************************/

	pascal
	WindowPtr
MyNewWindow(
	void				*wStorage,
	 Rect				*boundsRect,
	 ConstStr255Param 	title,
	 Boolean 			visible,
	 short 				theProc,
	 WindowPtr		 	behind,
	 Boolean 			goAwayFlag,
	 long 				refCon )
{
	return( NewCWindow( wStorage, boundsRect, title, visible, theProc, behind,
						goAwayFlag, refCon ) );
}

/****************************************************************************************
	Commenter	Date				Comment
	---------	-----------------	-----------------------------------------------------
	wolf		Thu, Jun 24, 1999	Created.
	
	************************************************************************************/

	pascal
	OSErr
HandleHackEvent(
	const	AppleEvent	*/*event*/,
			AppleEvent	*/*reply*/,
			long		refCon )
{
	long	a5 = SetCurrentA5();	//	Load a5 from lowmem.
			SetA5( refCon );		//	Restore our a5.
	
	//DebugStr( "\pTwo" );
	GetCurrentMenuList();
	
	SetA5( a5 );	//	Restore found a5.
	return( noErr );
}

/****************************************************************************************
	Commenter	Date				Comment
	---------	-----------------	-----------------------------------------------------
	wolf		Sat, Jun 26, 1999	Created.
	
	************************************************************************************/

	void
GetMBAR(
	StandardTask */*task*/ )
{
	ProcessSerialNumber	finderPSN;
	StandardApplicationSignatureToProcessSerialNumber( 'MACS', &finderPSN, nil );
	
	TAutoAEvent	aevent;
	aevent.MakeAppleEvent( gClassID, gClassID, 'MACS' );
	aevent.SendNoReply();
	TAEvent	reply;
	aevent.Send( &reply, kAEWaitReply );
	//DebugStr( "\pOne" );
	RootMenu	*rootMenu = new RootMenu;
	
	StandardTask	*updater = new StandardTask;
	StandardInitializeTask( updater );
	updater->proc = Updater;
	StandardScheduleTask( updater, 45 );
}

/****************************************************************************************
	Commenter	Date				Comment
	---------	-----------------	-----------------------------------------------------
	wolf		Sat, Jun 26, 1999	Created.
	
	************************************************************************************/

	void
Updater(
	StandardTask *task )
{
	if( TestOptionKey() )
		Debugger();
	list< AbstractMenuWindow* >::iterator	menuB = gMenus.begin();
	list< AbstractMenuWindow* >::iterator	menuE = gMenus.end();
	while( menuB != menuE ) {
		AbstractMenuWindow	*a = *menuB;
		a->Draw();
		//(*menuB)->Draw();
		++menuB;
	}
	StandardScheduleTask( task, 45 );
}